<!-- /www/psets/1-quotations/index.adp -->
<master>

<h1>Problem Set 1 "Quotations"</h1>

<p>This very first Problem Set teaches you the basics of OpenACS:</p>
<ul>
<li>Executing basic TCL pages
<li>Basic template formatting
<li>Executing SQL statements
<li>Creating a (very simple) data model
<li>Formatting data
</ul>
<br>

<h1>Reference Material</h1>
<p>Please read through the reference material:</p>
<ul>
<li><a href="../sql-for-web-nerds/">SQL for Web Nerds</a> 
     - SQL reduced to the essence
<li><a href="../tcl-for-web-nerds/">TCL for Web Nerds</a> 
     - TCL reduced to the essence
<li><a href="/doc/db-api.html">The OpenACS Database API</a>
     (you can skip the section on "bind variables")
</ul>
<br>

<h1>Example Code</h1>

<table border=0 cellspacing=4 cellpadding=4 width=600>

<tr>
<td class=rowtitle>Action</td>
<td class=rowtitle>Description</td>
<td class=rowtitle>TCL Source</td>
<td class=rowtitle>ADP Source</td>
</tr>

<tr valign=top>
<td><ul><li><a href="create-data-model"><nobr>create-data-model</nobr></a></ul></td>
<td>Create the data model for the "1-Quotations" database</td>
<td>(<a href="../show-source?file_name=1-quotations/create-data-model.tcl"><nobr>tcl source</nobr></a>)</td>
<td>(<a href="../show-source?file_name=1-quotations/create-data-model.adp"><nobr>adp source</nobr></a>)</td>
</tr>

<tr valign=top>
<td><ul><li><a href="insert-quote">insert-quote</a></ul></td>
<td>Form to insert a new quotation</td>
<td>(<a href="../show-source?file_name=1-quotations/insert-quote.tcl">tcl source</a>)</td>
<td>(<a href="../show-source?file_name=1-quotations/insert-quote.adp">adp source</a>)</td>
</tr>

<tr valign=top>
<td><ul><li>insert-quote-2</ul></td>
<td>
  Receives the data from insert-quote, stores them into the database
  and returns to the previous screen.
</td>
<td>(<a href="../show-source?file_name=1-quotations/insert-quote-2.tcl">tcl source</a>)</td>
<td></td>
</tr>

<tr valign=top>
<td><ul><li><a href="list-quotes">list-quotes</a></ul></td>
<td>Lists all current quotes</td>
<td>(<a href="../show-source?file_name=1-quotations/list-quotes.tcl">tcl source</a>)</td>
<td>(<a href="../show-source?file_name=1-quotations/list-quotes.adp">adp source</a>)</td>
</tr>

<tr valign=top>
<td colspan=4>
<br>
<h1>Excercises</h1>
<ul>
<li>Exercise 1.1 Add a new field:<br>
    Extend quotations by a new next field called "source"
    and add this field to all relevant pages.
    <br>&nbsp;
<li>Exercise 1.2 Implement Searching:<br>
    Add a small form at the top of list-quotes.tcl that takes a single query 
    word from the user. Build a target for this form that returns all quotes 
    containing the specified word. Your search should be case-insensitive and 
    also look through the authors column.
    <br>&nbsp;
<li>Exercise 1.3 XML Export:<br>
    Export quotations in XML format. Check Google for suitable XML standards.
    <br>&nbsp;
</ul>
</td>
</tr>

</table>

<br>
<p>
<a href="../index">Return to the Problem Set main page</a>
</p>
