# /www/psets/1-quotations/create-table.tcl
#
# Copyright (C) 1998-2007 various parties
#
# This program is free software. You can redistribute it and/or modify it under 
# the terms of the GNU General Public License as published by the Free Software 
# Foundation; either version 2 of the License, or (at your option) any later version. 
# This program is distributed in the hope that it will be useful, but WITHOUT ANY 
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
# PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# Edited by frank.bergmann@project-open.com


# ---------------------------------------------------------------
# Page Contract
# ---------------------------------------------------------------

ad_page_contract {
    Execute the "notes-create.sql" SQL file in order to create
    the datamodel for the "Notes" example.
    This file uses the most basic HTTP-level API with "ns_startcontent" 
    and "ns_write" to write directly into a HTTP connection in order to
    create a "streaming" page.
    This HTTP-style processing is deprecated, except for special pages
    that need this streaming style, such as the db_source_sql_file
    function below.
    @author frank.bergmann@project-open.com
} {
}

set page_title "Create Notes Data-Model"


# Write out HTTP header, considering CSV/MS-Excel formatting
set all_the_headers "HTTP/1.0 200 OK
MIME-Version: 1.0
Content-Type: text/html; charset=utf-8\r\n"
util_WriteWithExtraOutputHeaders $all_the_headers
ns_startcontent -type "text/html"

# Write out some page text
ns_write [ad_header $page_title]
ns_write "<h1>$page_title</h1>"


# Execute the SQL file
ns_write "<pre>\n"
set error_p [catch {

    set filename "[ns_info pageroot]/psets/2-notes/notes-create.sql"
    db_source_sql_file -callback apm_ns_write_callback $filename

} err_msg]
ns_write "</pre>\n"


if {$error_p} {
    ns_write "
	<pre>The following SQL errors are probably OK
if you have executed this script before.</pre>
	<h3>There were errors:</h3>
	<pre>$err_msg</pre>
    "
}

ns_write [ad_footer]

