
<html>
<head>
<title>Eval</title>
<LINK REL=STYLESHEET HREF="tcl_manual.css" TYPE="text/css">
</head>
<body bgcolor=white text=black>

<h2>Eval</h2>

part of <a href="index.adp">Tcl for Web Nerds</a> 
by 
<a href="http://www-swiss.ai.mit.edu/~hal/hal.html">Hal Abelson</a>,
<a href="http://philip.greenspun.com/">Philip Greenspun</a>,
and
<a href="http://sandon.org/l/">Lydia Sandon</a>


<hr>


The interpreter can be called explicitly to complete extra rounds of
substitutions or simply to interpret an additional time, using the
subst and eval instructions respectively. The <b><code>eval</code></b>
command takes a string argument which is a command, as follows:

<blockquote>
<code><pre>
% set cmd {puts stdout "Hello, World!"} 
puts stdout "Hello, World!" 

% eval $cmd 
Hello, World!
</pre></code>
</blockquote>


The <b><code>subst</code></b> command does the single round of
substitution ordinarily completed by the interpreter, but without
invoking any command.  It takes one argument, the string to be
substituted into.

<blockquote>
<code><pre>
% set a "foo bar" 
foo bar 

% subst {a=$a date=[exec date]} 
a=foo bar date=Thu Feb 30 1:11:11 EST 1901
</pre></code>
</blockquote>


While curly braces normally prevent internal substitution, they are
not respected by the <code>subst</code> command.  In order to prevent
the single round of substitution, the backslash must be used before
special characters like a dollar sign or square brackets.

<br>
<br>

More:  <a href="http://www.scriptics.com/man/tcl7.5/TclCmd/eval.n.html">http://www.scriptics.com/man/tcl7.5/TclCmd/eval.n.html</a>

<br>
<br>



Continue on to <A HREF="exec.adp"><code>exec</code></A>.



<hr>
Return to <a href="index.adp">Table of Contents</a>
<br>
<br>
<address><a href="mailto:lsandon@alum.mit.edu">lsandon@alum.mit.edu</a></address>

<center><a href="/comments/add?page_id=4736">Add a comment</a> | <a href="/links/add?page_id=4736">Add a link</a></center>

</body>
</html>

